diff -ruN tarsnap-autoconf-1.0.33/COPYING tarsnap-autoconf-1.0.34/COPYING
--- tarsnap-autoconf-1.0.33/COPYING	2012-08-10 00:05:27.000000000 -0700
+++ tarsnap-autoconf-1.0.34/COPYING	2013-07-06 14:38:24.000000000 -0700
@@ -1,7 +1,8 @@
-Unless specified otherwise in individual files, the contents of this
-package is covered by the following copyright, license, and disclaimer:
+Unless specified otherwise in individual files or directories, the
+contents of this package is covered by the following copyright, license,
+and disclaimer:
 
-Copyright 2006, 2007, 2008, 2009, 2010, 2011 Colin Percival
+Copyright 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013 Colin Percival
 All rights reserved.
 
 Redistribution and use in source and binary forms, without modification,
diff -ruN tarsnap-autoconf-1.0.33/config.aux/compile tarsnap-autoconf-1.0.34/config.aux/compile
--- tarsnap-autoconf-1.0.33/config.aux/compile	2012-08-10 00:05:26.000000000 -0700
+++ tarsnap-autoconf-1.0.34/config.aux/compile	2013-07-06 14:38:23.000000000 -0700
@@ -1,7 +1,7 @@
 #! /bin/sh
 # Wrapper for compilers which do not understand '-c -o'.
 
-scriptversion=2012-03-05.13; # UTC
+scriptversion=2012-10-14.11; # UTC
 
 # Copyright (C) 1999-2012 Free Software Foundation, Inc.
 # Written by Tom Tromey <tromey@cygnus.com>.
@@ -112,6 +112,11 @@
       lib=$dir/$lib.lib
       break
     fi
+    if test -f "$dir/lib$lib.a"; then
+      found=yes
+      lib=$dir/lib$lib.a
+      break
+    fi
   done
   IFS=$save_IFS
 
diff -ruN tarsnap-autoconf-1.0.33/config.aux/depcomp tarsnap-autoconf-1.0.34/config.aux/depcomp
--- tarsnap-autoconf-1.0.33/config.aux/depcomp	2012-08-10 00:05:26.000000000 -0700
+++ tarsnap-autoconf-1.0.34/config.aux/depcomp	2013-07-06 14:38:23.000000000 -0700
@@ -1,7 +1,7 @@
 #! /bin/sh
 # depcomp - compile a program generating dependencies as side-effects
 
-scriptversion=2012-03-27.16; # UTC
+scriptversion=2012-07-12.20; # UTC
 
 # Copyright (C) 1999-2012 Free Software Foundation, Inc.
 
@@ -74,6 +74,9 @@
 
 rm -f "$tmpdepfile"
 
+# Avoid interferences from the environment.
+gccflag= dashmflag=
+
 # Some modes work just like other modes, but use different flags.  We
 # parameterize here, but still list the modes in the big case below,
 # to make depend.m4 easier to write.  Note that we *cannot* use a case
@@ -108,7 +111,7 @@
 fi
 
 if test "$depmode" = xlc; then
-   # IBM C/C++ Compilers xlc/xlC can output gcc-like dependency informations.
+   # IBM C/C++ Compilers xlc/xlC can output gcc-like dependency information.
    gccflag=-qmakedep=gcc,-MF
    depmode=gcc
 fi
@@ -142,13 +145,17 @@
   ;;
 
 gcc)
+## Note that this doesn't just cater to obsosete pre-3.x GCC compilers.
+## but also to in-use compilers like IMB xlc/xlC and the HP C compiler.
+## (see the conditional assignment to $gccflag above).
 ## There are various ways to get dependency output from gcc.  Here's
 ## why we pick this rather obscure method:
 ## - Don't want to use -MD because we'd like the dependencies to end
 ##   up in a subdir.  Having to rename by hand is ugly.
 ##   (We might end up doing this anyway to support other compilers.)
 ## - The DEPENDENCIES_OUTPUT environment variable makes gcc act like
-##   -MM, not -M (despite what the docs say).
+##   -MM, not -M (despite what the docs say).  Also, it might not be
+##   supported by the other compilers which use the 'gcc' depmode.
 ## - Using -M directly means running the compiler twice (even worse
 ##   than renaming).
   if test -z "$gccflag"; then
@@ -334,6 +341,79 @@
   rm -f "$tmpdepfile"
   ;;
 
+## The order of this option in the case statement is important, since the
+## shell code in configure will try each of these formats in the order
+## listed in this file.  A plain '-MD' option would be understood by many
+## compilers, so we must ensure this comes after the gcc and icc options.
+pgcc)
+  # Portland's C compiler understands '-MD'.
+  # Will always output deps to 'file.d' where file is the root name of the
+  # source file under compilation, even if file resides in a subdirectory.
+  # The object file name does not affect the name of the '.d' file.
+  # pgcc 10.2 will output
+  #    foo.o: sub/foo.c sub/foo.h
+  # and will wrap long lines using '\' :
+  #    foo.o: sub/foo.c ... \
+  #     sub/foo.h ... \
+  #     ...
+  dir=`echo "$object" | sed -e 's|/[^/]*$|/|'`
+  test "x$dir" = "x$object" && dir=
+  # Use the source, not the object, to determine the base name, since
+  # that's sadly what pgcc will do too.
+  base=`echo "$source" | sed -e 's|^.*/||' -e 's/\.[-_a-zA-Z0-9]*$//'`
+  tmpdepfile="$base.d"
+
+  # For projects that build the same source file twice into different object
+  # files, the pgcc approach of using the *source* file root name can cause
+  # problems in parallel builds.  Use a locking strategy to avoid stomping on
+  # the same $tmpdepfile.
+  lockdir="$base.d-lock"
+  trap "echo '$0: caught signal, cleaning up...' >&2; rm -rf $lockdir" 1 2 13 15
+  numtries=100
+  i=$numtries
+  while test $i -gt 0 ; do
+    # mkdir is a portable test-and-set.
+    if mkdir $lockdir 2>/dev/null; then
+      # This process acquired the lock.
+      "$@" -MD
+      stat=$?
+      # Release the lock.
+      rm -rf $lockdir
+      break
+    else
+      ## the lock is being held by a different process,
+      ## wait until the winning process is done or we timeout
+      while test -d $lockdir && test $i -gt 0; do
+        sleep 1
+        i=`expr $i - 1`
+      done
+    fi
+    i=`expr $i - 1`
+  done
+  trap - 1 2 13 15
+  if test $i -le 0; then
+    echo "$0: failed to acquire lock after $numtries attempts" >&2
+    echo "$0: check lockdir '$lockdir'" >&2
+    exit 1
+  fi
+
+  if test $stat -ne 0; then
+    rm -f "$tmpdepfile"
+    exit $stat
+  fi
+  rm -f "$depfile"
+  # Each line is of the form `foo.o: dependent.h',
+  # or `foo.o: dep1.h dep2.h \', or ` dep3.h dep4.h \'.
+  # Do two passes, one to just change these to
+  # `$object: dependent.h' and one to simply `dependent.h:'.
+  sed "s,^[^:]*:,$object :," < "$tmpdepfile" > "$depfile"
+  # Some versions of the HPUX 10.20 sed can't process this invocation
+  # correctly.  Breaking it into two sed invocations is a workaround.
+  sed 's,^[^:]*: \(.*\)$,\1,;s/^\\$//;/^$/d;/:$/d' < "$tmpdepfile" |
+    sed -e 's/$/ :/' >> "$depfile"
+  rm -f "$tmpdepfile"
+  ;;
+
 hp2)
   # The "hp" stanza above does not work with aCC (C++) and HP's ia64
   # compilers, which have integrated preprocessors.  The correct option
diff -ruN tarsnap-autoconf-1.0.33/config.h.in tarsnap-autoconf-1.0.34/config.h.in
--- tarsnap-autoconf-1.0.33/config.h.in	2012-08-10 00:05:25.000000000 -0700
+++ tarsnap-autoconf-1.0.34/config.h.in	2013-07-06 14:38:22.000000000 -0700
@@ -36,9 +36,6 @@
 /* True for systems with POSIX ACL support */
 #undef HAVE_ACL_USER
 
-/* Define to 1 if you have the `asprintf' function. */
-#undef HAVE_ASPRINTF
-
 /* Define to 1 if you have the <attr/xattr.h> header file. */
 #undef HAVE_ATTR_XATTR_H
 
@@ -60,10 +57,6 @@
 /* Define to 1 if you have the <ctype.h> header file. */
 #undef HAVE_CTYPE_H
 
-/* Define to 1 if you have the declaration of `be64enc', and to 0 if you
-   don't. */
-#undef HAVE_DECL_BE64ENC
-
 /* Define to 1 if you have the declaration of `INT64_MAX', and to 0 if you
    don't. */
 #undef HAVE_DECL_INT64_MAX
@@ -179,9 +172,6 @@
 /* Define to 1 if you have the `futimes' function. */
 #undef HAVE_FUTIMES
 
-/* Define to 1 if you have the `getaddrinfo' function. */
-#undef HAVE_GETADDRINFO
-
 /* Define to 1 if you have the `geteuid' function. */
 #undef HAVE_GETEUID
 
@@ -491,9 +481,6 @@
    */
 #undef HAVE_SYS_DIR_H
 
-/* Define to 1 if you have the <sys/endian.h> header file. */
-#undef HAVE_SYS_ENDIAN_H
-
 /* Define to 1 if you have the <sys/extattr.h> header file. */
 #undef HAVE_SYS_EXTATTR_H
 
diff -ruN tarsnap-autoconf-1.0.33/keygen/keygen.c tarsnap-autoconf-1.0.34/keygen/keygen.c
--- tarsnap-autoconf-1.0.33/keygen/keygen.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/keygen/keygen.c	2013-07-06 14:38:21.000000000 -0700
@@ -13,11 +13,13 @@
 #include <unistd.h>
 
 #include "crypto.h"
+#include "crypto_dh.h"
+#include "crypto_verify_bytes.h"
 #include "humansize.h"
 #include "keyfile.h"
 #include "netpacket.h"
 #include "netproto.h"
-#include "network.h"
+#include "tsnetwork.h"
 #include "readpass.h"
 #include "sysendian.h"
 #include "tarsnap_opt.h"
@@ -73,9 +75,7 @@
 	uint64_t maxmem;
 	char * passphrase;
 
-#ifdef NEED_WARN_PROGNAME
-	warn_progname = "tarsnap-keygen";
-#endif
+	WARNP_INIT;
 
 	/* We have no username, machine name, or key filename yet. */
 	C.user = C.name = NULL;
@@ -152,8 +152,7 @@
 	}
 
 	/* Get a password. */
-	if (tarsnap_readpass(&C.passwd, "Enter tarsnap account password",
-	    NULL, 0)) {
+	if (readpass(&C.passwd, "Enter tarsnap account password", NULL, 0)) {
 		warnp("Error reading password");
 		exit(1);
 	}
@@ -168,12 +167,6 @@
 		exit(1);
 	}
 
-	/* Initialize entropy subsystem. */
-	if (crypto_entropy_init()) {
-		warnp("Entropy subsystem initialization failed");
-		goto err1;
-	}
-
 	/* Initialize key cache. */
 	if (crypto_keys_init()) {
 		warnp("Key cache initialization failed");
@@ -186,12 +179,6 @@
 		goto err1;
 	}
 
-	/* Initialize network layer. */
-	if (network_init()) {
-		warnp("Network layer initialization failed");
-		goto err1;
-	}
-
 	/*
 	 * We're not done, haven't answered a challenge, and don't have a
 	 * machine number.
@@ -261,7 +248,7 @@
 
 	/* If the user wants to passphrase the keyfile, get the passphrase. */
 	if (passphrased != 0) {
-		if (tarsnap_readpass(&passphrase,
+		if (readpass(&passphrase,
 		    "Please enter passphrase for keyfile encryption",
 		    "Please confirm passphrase for keyfile encryption", 1)) {
 			warnp("Error reading password");
diff -ruN tarsnap-autoconf-1.0.33/keymgmt/keymgmt.c tarsnap-autoconf-1.0.34/keymgmt/keymgmt.c
--- tarsnap-autoconf-1.0.33/keymgmt/keymgmt.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/keymgmt/keymgmt.c	2013-07-06 14:38:21.000000000 -0700
@@ -41,15 +41,7 @@
 	uint64_t maxmem = 0;
 	char * passphrase;
 
-#ifdef NEED_WARN_PROGNAME
-	warn_progname = "tarsnap-keymgmt";
-#endif
-
-	/* Initialize entropy subsystem. */
-	if (crypto_entropy_init()) {
-		warnp("Entropy subsystem initialization failed");
-		exit(1);
-	}
+	WARNP_INIT;
 
 	/* Initialize key cache. */
 	if (crypto_keys_init()) {
@@ -169,7 +161,7 @@
 
 	/* If the user wants to passphrase the keyfile, get the passphrase. */
 	if (passphrased != 0) {
-		if (tarsnap_readpass(&passphrase,
+		if (readpass(&passphrase,
 		    "Please enter passphrase for keyfile encryption",
 		    "Please confirm passphrase for keyfile encryption", 1)) {
 			warnp("Error reading password");
diff -ruN tarsnap-autoconf-1.0.33/keyregen/keyregen.c tarsnap-autoconf-1.0.34/keyregen/keyregen.c
--- tarsnap-autoconf-1.0.33/keyregen/keyregen.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/keyregen/keyregen.c	2013-07-06 14:38:21.000000000 -0700
@@ -13,11 +13,13 @@
 #include <unistd.h>
 
 #include "crypto.h"
+#include "crypto_dh.h"
+#include "crypto_verify_bytes.h"
 #include "humansize.h"
 #include "keyfile.h"
 #include "netpacket.h"
 #include "netproto.h"
-#include "network.h"
+#include "tsnetwork.h"
 #include "readpass.h"
 #include "sysendian.h"
 #include "tarsnap_opt.h"
@@ -75,9 +77,7 @@
 	char * passphrase;
 	uint64_t dummy;
 
-#ifdef NEED_WARN_PROGNAME
-	warn_progname = "tarsnap-rekeygen";
-#endif
+	WARNP_INIT;
 
 	/*
 	 * We have no username, machine name, key filename, or old key
@@ -167,8 +167,7 @@
 	}
 
 	/* Get a password. */
-	if (tarsnap_readpass(&C.passwd, "Enter tarsnap account password",
-	    NULL, 0)) {
+	if (readpass(&C.passwd, "Enter tarsnap account password", NULL, 0)) {
 		warnp("Error reading password");
 		exit(1);
 	}
@@ -183,12 +182,6 @@
 		exit(1);
 	}
 
-	/* Initialize entropy subsystem. */
-	if (crypto_entropy_init()) {
-		warnp("Entropy subsystem initialization failed");
-		goto err1;
-	}
-
 	/* Initialize key cache. */
 	if (crypto_keys_init()) {
 		warnp("Key cache initialization failed");
@@ -222,12 +215,6 @@
 		goto err1;
 	}
 
-	/* Initialize network layer. */
-	if (network_init()) {
-		warnp("Network layer initialization failed");
-		goto err1;
-	}
-
 	/*
 	 * We're not done, haven't answered a challenge, and don't have a
 	 * machine number.
@@ -297,7 +284,7 @@
 
 	/* If the user wants to passphrase the keyfile, get the passphrase. */
 	if (passphrased != 0) {
-		if (tarsnap_readpass(&passphrase,
+		if (readpass(&passphrase,
 		    "Please enter passphrase for keyfile encryption",
 		    "Please confirm passphrase for keyfile encryption", 1)) {
 			warnp("Error reading password");
diff -ruN tarsnap-autoconf-1.0.33/lib/Makefile tarsnap-autoconf-1.0.34/lib/Makefile
--- tarsnap-autoconf-1.0.33/lib/Makefile	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/Makefile	2013-07-06 14:38:21.000000000 -0700
@@ -6,10 +6,6 @@
 
 # Crypto code
 .PATH	:	crypto
-SRCS	+=	crypto_aesctr.c
-SRCS	+=	crypto_dh.c
-SRCS	+=	crypto_dh_group14.c
-SRCS	+=	crypto_entropy.c
 SRCS	+=	crypto_file.c
 SRCS	+=	crypto_hash.c
 SRCS	+=	crypto_keys.c
@@ -19,8 +15,6 @@
 SRCS	+=	crypto_rsa.c
 SRCS	+=	crypto_scrypt-nosse.c
 SRCS	+=	crypto_session.c
-SRCS	+=	crypto_verify_bytes.c
-SRCS	+=	sha256.c
 CFLAGS	+=	-I crypto
 
 # Data structures
@@ -56,11 +50,14 @@
 
 # Non-blocking network routines
 .PATH	:	network
-SRCS	+=	network_buf.c
-SRCS	+=	network_connect.c
-SRCS	+=	network_cork.c
-SRCS	+=	network_select.c
-SRCS	+=	network_writeq.c
+SRCS	+=	tsnetwork_buf.c
+SRCS	+=	tsnetwork_bwlimit.c
+SRCS	+=	tsnetwork_connect.c
+SRCS	+=	tsnetwork_cork.c
+SRCS	+=	tsnetwork_register.c
+SRCS	+=	tsnetwork_select.c
+SRCS	+=	tsnetwork_sleep.c
+SRCS	+=	tsnetwork_writeq.c
 CFLAGS	+=	-I network
 
 # scryptenc code
@@ -71,21 +68,65 @@
 
 # Utility code
 .PATH	:	util
+SRCS	+=	dirutil.c
+SRCS	+=	getfstype.c
+SRCS	+=	hexlink.c
+SRCS	+=	memlimit.c
+SRCS	+=	sigquit.c
+SRCS	+=	tvmath.c
+CFLAGS	+=	-I util
+
+### Bits from libcperciva
+# Fundamental algorithms
+.PATH	:	../libcperciva/alg
+SRCS	+=	sha256.c
+CFLAGS	+=	-I ../libcperciva/alg
+
+# Crypto code
+.PATH	:	../libcperciva/crypto
+SRCS	+=	crypto_aesctr.c
+SRCS	+=	crypto_dh.c
+SRCS	+=	crypto_dh_group14.c
+SRCS	+=	crypto_entropy.c
+SRCS	+=	crypto_verify_bytes.c
+CFLAGS	+=	-I ../libcperciva/crypto
+
+# Data structures
+.PATH	:	../libcperciva/datastruct
+SRCS	+=	elasticarray.c
+SRCS	+=	ptrheap.c
+SRCS	+=	timerqueue.c
+CFLAGS	+=	-I ../libcperciva/datastruct
+
+# Events code
+.PATH	:	../libcperciva/events
+SRCS	+=	events.c
+SRCS	+=	events_immediate.c
+SRCS	+=	events_network.c
+SRCS	+=	events_network_selectstats.c
+SRCS	+=	events_timer.c
+CFLAGS	+=	-I ../libcperciva/events
+
+# Network code
+.PATH	:	../libcperciva/network
+SRCS	+=	network_accept.c
+SRCS	+=	network_buf.c
+SRCS	+=	network_connect.c
+CFLAGS	+=	-I ../libcperciva/network
+
+# Utility code
+.PATH	:	../libcperciva/util
 SRCS	+=	asprintf.c
 SRCS	+=	b64encode.c
-SRCS	+=	dirutil.c
 SRCS	+=	entropy.c
-SRCS	+=	getfstype.c
 SRCS	+=	hexify.c
-SRCS	+=	hexlink.c
 SRCS	+=	humansize.c
-SRCS	+=	memlimit.c
 SRCS	+=	monoclock.c
 SRCS	+=	readpass.c
-SRCS	+=	sigquit.c
-SRCS	+=	tvmath.c
+SRCS	+=	sock.c
+SRCS	+=	sock_util.c
 SRCS	+=	warnp.c
-CFLAGS	+=	-I util
+CFLAGS	+=	-I ../libcperciva/util
 
 # Compiler flags for profiling
 .if defined(PROFILE)
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto.h tarsnap-autoconf-1.0.34/lib/crypto/crypto.h
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto.h	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto.h	2013-07-06 14:38:21.000000000 -0700
@@ -76,7 +76,11 @@
 #define CRYPTO_FILE_HLEN	(256 + 8)
 #define CRYPTO_FILE_TLEN	32
 
-/* Sizes of Diffie-Hellman private, public, and exchanged keys. */
+/*
+ * Sizes of Diffie-Hellman private, public, and exchanged keys.  These are
+ * defined in libcperciva/crypto/crypto_dh.h, but are also included here as
+ * the sizes are used in places which don't actually do Diffie-Hellman.
+ */
 #define CRYPTO_DH_PRIVLEN	32
 #define CRYPTO_DH_PUBLEN	256
 #define CRYPTO_DH_KEYLEN	256
@@ -85,22 +89,8 @@
 typedef struct crypto_session_internal CRYPTO_SESSION;
 
 /**
- * crypto_entropy_init(void):
- * Initialize the PRNG.
- */
-int crypto_entropy_init(void);
-
-/**
- * crypto_entropy_read(buf, buflen):
- * Fill the buffer with unpredictable bits.  The value ${buflen} must be
- * less than 2^16.
- */
-int crypto_entropy_read(uint8_t *, size_t);
-
-/**
  * crypto_keys_init(void):
- * Initialize the key cache.  Note that crypto_entropy_init MUST be called
- * before this function.
+ * Initialize the key cache.
  */
 int crypto_keys_init(void);
 
@@ -211,31 +201,6 @@
 int crypto_file_dec(const uint8_t *, size_t, uint8_t *);
 
 /**
- * crypto_dh_generate(pub, priv):
- * Generate a 256-bit private key ${priv}, and compute ${pub} equal to
- * 2^(2^258 + ${priv}) mod p where p is the Diffie-Hellman group #14 modulus.
- * Both values are stored as big-endian integers.
- */
-int crypto_dh_generate(uint8_t[CRYPTO_DH_PUBLEN], uint8_t[CRYPTO_DH_PRIVLEN]);
-
-/**
- * crypto_dh_compute(pub, priv, key):
- * In the Diffie-Hellman group #14, compute ${pub}^(2^258 + ${priv}) and
- * write the result into ${key}.  All values are big-endian.  Note that the
- * value ${pub} is the public key produced the call to crypto_dh_generate
- * made by the *other* participant in the key exchange.
- */
-int crypto_dh_compute(const uint8_t[CRYPTO_DH_PUBLEN],
-    const uint8_t[CRYPTO_DH_PRIVLEN], uint8_t[CRYPTO_DH_KEYLEN]);
-
-/**
- * crypto_dh_sanitycheck(pub):
- * Sanity-check the Diffie-Hellman public value ${pub} by checking that it
- * is less than the group #14 modulus.  Return 0 if sane, -1 if insane.
- */
-int crypto_dh_sanitycheck(const uint8_t[CRYPTO_DH_PUBLEN]);
-
-/**
  * crypto_session_init(pub, priv, nonce, mkey, encr_write, auth_write,
  *     encr_read, auth_read):
  * Compute K = ${pub}^(2^258 + ${priv}), mkey = MGF1(nonce || K, 48), and
@@ -290,11 +255,4 @@
 int crypto_passwd_to_dh(const char *, const uint8_t[32],
     uint8_t[CRYPTO_DH_PUBLEN], uint8_t[CRYPTO_DH_PRIVLEN]);
 
-/**
- * crypto_verify_bytes(buf0, buf1, len):
- * Return zero if and only if buf0[0 .. len - 1] and buf1[0 .. len - 1] are
- * identical.  Do not leak any information via timing side channels.
- */
-uint8_t crypto_verify_bytes(const uint8_t *, const uint8_t *, size_t);
-
 #endif /* !_CRYPTO_H_ */
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto_file.c tarsnap-autoconf-1.0.34/lib/crypto/crypto_file.c
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto_file.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto_file.c	2013-07-06 14:38:21.000000000 -0700
@@ -1,14 +1,19 @@
 #include "bsdtar_platform.h"
 
+#include <stdlib.h>
 #include <string.h>
 
 #include <openssl/aes.h>
 
-#include "crypto_internal.h"
-#include "rwhashtab.h"
+#include "crypto_aesctr.h"
+#include "crypto_entropy.h"
+#include "crypto_verify_bytes.h"
 #include "sysendian.h"
 #include "warnp.h"
 
+#include "crypto_internal.h"
+#include "rwhashtab.h"
+
 #include "crypto.h"
 
 struct crypto_aes_key {
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto_internal.h tarsnap-autoconf-1.0.34/lib/crypto/crypto_internal.h
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto_internal.h	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto_internal.h	2013-07-06 14:38:21.000000000 -0700
@@ -11,9 +11,6 @@
 	uint8_t * key;
 };
 
-/* Diffie-Hellman group #14, from RFC 3526. */
-extern uint8_t crypto_dh_group14[];
-
 /**
  * crypto_keys_lookup_RSA(key):
  * Return the requested RSA key.
@@ -97,34 +94,4 @@
  */
 void crypto_MGF1(uint8_t *, size_t, uint8_t *, size_t);
 
-/**
- * crypto_dh_generate_pub(pub, priv):
- * Compute ${pub} equal to 2^(2^258 + ${priv}) in Diffie-Hellman group #14.
- */
-int crypto_dh_generate_pub(uint8_t[ /* CRYPTO_DH_PUBLEN */ ],
-    const uint8_t[ /* CRYPTO_DH_PRIVLEN */ ]);
-
-/**
- * crypto_aesctr_init(key, nonce):
- * Prepare to encrypt/decrypt data with AES in CTR mode, using the provided
- * expanded key and nonce.  The key provided must remain valid for the
- * lifetime of the stream.
- */
-struct crypto_aesctr * crypto_aesctr_init(AES_KEY *, uint64_t);
-
-/**
- * crypto_aesctr_stream(stream, inbuf, outbuf, buflen):
- * Generate the next ${buflen} bytes of the AES-CTR stream and xor them with
- * bytes from ${inbuf}, writing the result into ${outbuf}.  If the buffers
- * ${inbuf} and ${outbuf} overlap, they must be identical.
- */
-void crypto_aesctr_stream(struct crypto_aesctr *, const uint8_t *,
-    uint8_t *, size_t);
-
-/**
- * crypto_aesctr_free(stream):
- * Free the provided stream object.
- */
-void crypto_aesctr_free(struct crypto_aesctr *);
-
 #endif /* !_CRYPTO_INTERNAL_H_ */
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto_keys.c tarsnap-autoconf-1.0.34/lib/crypto/crypto_keys.c
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto_keys.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto_keys.c	2013-07-06 14:38:21.000000000 -0700
@@ -8,6 +8,7 @@
 #include <openssl/err.h>
 #include <openssl/rand.h>
 
+#include "crypto_entropy.h"
 #include "sysendian.h"
 #include "warnp.h"
 
@@ -30,12 +31,15 @@
 	struct crypto_hmac_key * auth_delete;
 } keycache;
 
-/* External key data format. */
-struct keyheader {
-	uint8_t len[4];	/* Length of key data, little-endian. */
-	uint8_t type;	/* Key type. */
-	/* Key data, in key-specific format. */
-};
+/*
+ * External key data format:
+ * 4 byte little-endian integer = length of key data
+ * 1 byte = key type
+ * N bytes = key data, in key-specific format
+ */
+#define KEYHEADER_OFFSET_LEN	0
+#define KEYHEADER_OFFSET_TYPE	4
+#define KEYHEADER_LEN	5
 
 /* Amount of entropy to use for seeding OpenSSL. */
 #define RANDBUFLEN	2048
@@ -157,31 +161,33 @@
 int
 crypto_keys_import(const uint8_t * buf, size_t buflen, int keys)
 {
-	const struct keyheader * kh;
+	const uint8_t * kh;
 	uint32_t len;
+	uint8_t type;
 
 	/* Loop until we've processed all the provided data. */
 	while (buflen) {
-		/* We must have at least a struct keyheader. */
-		if (buflen < sizeof(struct keyheader)) {
+		/* We must have at least a key header. */
+		if (buflen < KEYHEADER_LEN) {
 			warn0("Unexpected EOF of key data");
 			goto err0;
 		}
 
 		/* Parse header. */
-		kh = (const struct keyheader *)buf;
-		buf += sizeof(struct keyheader);
-		buflen -= sizeof(struct keyheader);
+		kh = buf;
+		buf += KEYHEADER_LEN;
+		buflen -= KEYHEADER_LEN;
 
 		/* Sanity check length. */
-		len = le32dec(kh->len);
+		len = le32dec(&kh[KEYHEADER_OFFSET_LEN]);
 		if (len > buflen) {
 			warn0("Unexpected EOF of key data");
 			goto err0;
 		}
 
 		/* Parse the key. */
-		switch (kh->type) {
+		type = kh[KEYHEADER_OFFSET_TYPE];
+		switch (type) {
 		case CRYPTO_KEY_SIGN_PRIV:
 			if ((keys & CRYPTO_KEYMASK_SIGN_PRIV) &&
 			    crypto_keys_subr_import_RSA_priv(
@@ -259,7 +265,7 @@
 				goto err0;
 			break;
 		default:
-			warn0("Unrecognized key type: %d", kh->type);
+			warn0("Unrecognized key type: %d", type);
 			goto err0;
 		}
 
@@ -360,7 +366,7 @@
 int
 crypto_keys_export(int keys, uint8_t ** buf, size_t * buflen)
 {
-	struct keyheader * kh;
+	uint8_t * kh;
 	size_t bufpos;
 	uint32_t len;
 	int key;
@@ -380,11 +386,11 @@
 			goto err0;
 		}
 		*buflen += len;
-		if (*buflen > *buflen + sizeof(struct keyheader)) {
+		if (*buflen > *buflen + KEYHEADER_LEN) {
 			errno = ENOMEM;
 			goto err0;
 		}
-		*buflen += sizeof(struct keyheader);
+		*buflen += KEYHEADER_LEN;
 	}
 
 	/* Allocate memory. */
@@ -396,25 +402,25 @@
 	for (key = 0; key < (int)(sizeof(int) * 8); key++)
 	    if ((keys >> key) & 1) {
 		/* Sanity check remaining buffer length. */
-		if (*buflen - bufpos < sizeof(struct keyheader)) {
+		if (*buflen - bufpos < KEYHEADER_LEN) {
 			warn0("Programmer error");
 			goto err1;
 		}
 
 		/* Export key. */
 		len = export_key(key,
-		    *buf + (bufpos + sizeof(struct keyheader)),
-		    *buflen - (bufpos + sizeof(struct keyheader)));
+		    *buf + (bufpos + KEYHEADER_LEN),
+		    *buflen - (bufpos + KEYHEADER_LEN));
 		if (len == (uint32_t)(-1))
 			goto err1;
 
 		/* Write key header. */
-		kh = (struct keyheader *)(*buf + bufpos);
-		kh->type = key;
-		le32enc(kh->len, len);
+		kh = *buf + bufpos;
+		le32enc(&kh[KEYHEADER_OFFSET_LEN], len);
+		kh[KEYHEADER_OFFSET_TYPE] = key;
 
 		/* Advance buffer position. */
-		bufpos += sizeof(struct keyheader) + len;
+		bufpos += KEYHEADER_LEN + len;
 	}
 
 	/* Sanity-check -- we should have filled the buffer. */
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto_keys_subr.c tarsnap-autoconf-1.0.34/lib/crypto/crypto_keys_subr.c
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto_keys_subr.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto_keys_subr.c	2013-07-06 14:38:21.000000000 -0700
@@ -10,7 +10,7 @@
 #include <openssl/rand.h>
 #include <openssl/rsa.h>
 
-#include "crypto.h"
+#include "crypto_entropy.h"
 #include "sysendian.h"
 #include "warnp.h"
 
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto_passwd_to_dh.c tarsnap-autoconf-1.0.34/lib/crypto/crypto_passwd_to_dh.c
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto_passwd_to_dh.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto_passwd_to_dh.c	2013-07-06 14:38:21.000000000 -0700
@@ -2,7 +2,7 @@
 
 #include <string.h>
 
-#include "crypto_internal.h"
+#include "crypto_dh.h"
 #include "ctassert.h"
 
 #include "crypto.h"
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto_rsa.c tarsnap-autoconf-1.0.34/lib/crypto/crypto_rsa.c
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto_rsa.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto_rsa.c	2013-07-06 14:38:21.000000000 -0700
@@ -7,10 +7,13 @@
 #include <openssl/err.h>
 #include <openssl/rsa.h>
 
-#include "crypto_internal.h"
+#include "crypto_entropy.h"
+#include "crypto_verify_bytes.h"
 #include "sysendian.h"
 #include "warnp.h"
 
+#include "crypto_internal.h"
+
 #include "crypto.h"
 
 /**
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto_scrypt-nosse.c tarsnap-autoconf-1.0.34/lib/crypto/crypto_scrypt-nosse.c
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto_scrypt-nosse.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto_scrypt-nosse.c	2013-07-06 14:38:21.000000000 -0700
@@ -41,18 +41,18 @@
 
 #include "crypto_scrypt.h"
 
-static void blkcpy(void *, void *, size_t);
-static void blkxor(void *, void *, size_t);
+static void blkcpy(void *, const void *, size_t);
+static void blkxor(void *, const void *, size_t);
 static void salsa20_8(uint32_t[16]);
-static void blockmix_salsa8(uint32_t *, uint32_t *, uint32_t *, size_t);
-static uint64_t integerify(void *, size_t);
+static void blockmix_salsa8(const uint32_t *, uint32_t *, uint32_t *, size_t);
+static uint64_t integerify(const void *, size_t);
 static void smix(uint8_t *, size_t, uint64_t, uint32_t *, uint32_t *);
 
 static void
-blkcpy(void * dest, void * src, size_t len)
+blkcpy(void * dest, const void * src, size_t len)
 {
 	size_t * D = dest;
-	size_t * S = src;
+	const size_t * S = src;
 	size_t L = len / sizeof(size_t);
 	size_t i;
 
@@ -61,10 +61,10 @@
 }
 
 static void
-blkxor(void * dest, void * src, size_t len)
+blkxor(void * dest, const void * src, size_t len)
 {
 	size_t * D = dest;
-	size_t * S = src;
+	const size_t * S = src;
 	size_t L = len / sizeof(size_t);
 	size_t i;
 
@@ -123,7 +123,7 @@
  * temporary space X must be 64 bytes.
  */
 static void
-blockmix_salsa8(uint32_t * Bin, uint32_t * Bout, uint32_t * X, size_t r)
+blockmix_salsa8(const uint32_t * Bin, uint32_t * Bout, uint32_t * X, size_t r)
 {
 	size_t i;
 
@@ -155,9 +155,9 @@
  * Return the result of parsing B_{2r-1} as a little-endian integer.
  */
 static uint64_t
-integerify(void * B, size_t r)
+integerify(const void * B, size_t r)
 {
-	uint32_t * X = (void *)((uintptr_t)(B) + (2 * r - 1) * 64);
+	const uint32_t * X = (const void *)((uintptr_t)(B) + (2 * r - 1) * 64);
 
 	return (((uint64_t)(X[1]) << 32) + X[0]);
 }
@@ -232,13 +232,14 @@
  */
 int
 crypto_scrypt(const uint8_t * passwd, size_t passwdlen,
-    const uint8_t * salt, size_t saltlen, uint64_t N, uint32_t r, uint32_t p,
+    const uint8_t * salt, size_t saltlen, uint64_t N, uint32_t _r, uint32_t _p,
     uint8_t * buf, size_t buflen)
 {
 	void * B0, * V0, * XY0;
 	uint8_t * B;
 	uint32_t * V;
 	uint32_t * XY;
+	size_t r = _r, p = _p;
 	uint32_t i;
 
 	/* Sanity-check parameters. */
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto_scrypt-sse.c tarsnap-autoconf-1.0.34/lib/crypto/crypto_scrypt-sse.c
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto_scrypt-sse.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto_scrypt-sse.c	2013-07-06 14:38:21.000000000 -0700
@@ -42,18 +42,18 @@
 
 #include "crypto_scrypt.h"
 
-static void blkcpy(void *, void *, size_t);
-static void blkxor(void *, void *, size_t);
+static void blkcpy(void *, const void *, size_t);
+static void blkxor(void *, const void *, size_t);
 static void salsa20_8(__m128i *);
-static void blockmix_salsa8(__m128i *, __m128i *, __m128i *, size_t);
-static uint64_t integerify(void *, size_t);
+static void blockmix_salsa8(const __m128i *, __m128i *, __m128i *, size_t);
+static uint64_t integerify(const void *, size_t);
 static void smix(uint8_t *, size_t, uint64_t, void *, void *);
 
 static void
-blkcpy(void * dest, void * src, size_t len)
+blkcpy(void * dest, const void * src, size_t len)
 {
 	__m128i * D = dest;
-	__m128i * S = src;
+	const __m128i * S = src;
 	size_t L = len / 16;
 	size_t i;
 
@@ -62,10 +62,10 @@
 }
 
 static void
-blkxor(void * dest, void * src, size_t len)
+blkxor(void * dest, const void * src, size_t len)
 {
 	__m128i * D = dest;
-	__m128i * S = src;
+	const __m128i * S = src;
 	size_t L = len / 16;
 	size_t i;
 
@@ -142,7 +142,7 @@
  * temporary space X must be 64 bytes.
  */
 static void
-blockmix_salsa8(__m128i * Bin, __m128i * Bout, __m128i * X, size_t r)
+blockmix_salsa8(const __m128i * Bin, __m128i * Bout, __m128i * X, size_t r)
 {
 	size_t i;
 
@@ -174,9 +174,9 @@
  * Return the result of parsing B_{2r-1} as a little-endian integer.
  */
 static uint64_t
-integerify(void * B, size_t r)
+integerify(const void * B, size_t r)
 {
-	uint32_t * X = (void *)((uintptr_t)(B) + (2 * r - 1) * 64);
+	const uint32_t * X = (const void *)((uintptr_t)(B) + (2 * r - 1) * 64);
 
 	return (((uint64_t)(X[13]) << 32) + X[0]);
 }
@@ -260,13 +260,14 @@
  */
 int
 crypto_scrypt(const uint8_t * passwd, size_t passwdlen,
-    const uint8_t * salt, size_t saltlen, uint64_t N, uint32_t r, uint32_t p,
+    const uint8_t * salt, size_t saltlen, uint64_t N, uint32_t _r, uint32_t _p,
     uint8_t * buf, size_t buflen)
 {
 	void * B0, * V0, * XY0;
 	uint8_t * B;
 	uint32_t * V;
 	uint32_t * XY;
+	size_t r = _r, p = _p;
 	uint32_t i;
 
 	/* Sanity-check parameters. */
diff -ruN tarsnap-autoconf-1.0.33/lib/crypto/crypto_session.c tarsnap-autoconf-1.0.34/lib/crypto/crypto_session.c
--- tarsnap-autoconf-1.0.33/lib/crypto/crypto_session.c	2012-08-10 00:05:23.000000000 -0700
+++ tarsnap-autoconf-1.0.34/lib/crypto/crypto_session.c	2013-07-06 14:38:21.000000000 -0700
@@ -6,10 +6,14 @@
 
 #include <openssl/aes.h>
 
-#include "crypto_internal.h"
+#include "crypto_aesctr.h"
+#include "crypto_dh.h"
+#include "crypto_verify_bytes.h"
 #include "sysendian.h"
 #include "warnp.h"
 
+#include "crypto_internal.h"
+
 #include "crypto.h"
 
 struct crypto_session_internal {
